import jp.jig.jiglet.*;

public class viewsource extends Jiglet {
	String sourceData, statusText;

	String menuFace[] = {
		"Shift_JIS",
		"EUC-JP",
		"ISO-2022-JP",
		"UTF-8",
		"TCY",
		"TCY",
		"TCY",
	}, menuHelp[] = {
		"Shift_JISR[h̎gp݂܂B",
		"EUC-JPR[h̎gp݂܂B",
		"ISO-2022-JP(JISR[h)̎gp݂܂B",
		"UTF-8R[hZbg̎gp݂܂B",
		"TCYɐݒ肵܂B",
		"TCY𒆂ɐݒ肵܂B",
		"TCYɐݒ肵܂B",
	};

	int drawStartPos, drawLeftOffset, fontHeight, showableLines, showableChars, showableWidth, scrollBarWidth,
		lineInfos[] = new int[10000], nowLineID, maxLines, systemColors[], lineBreakMarkHeight, statusPercentage;
	int nowFont = FONT_SMALL;
	boolean isLineBreak[] = new boolean[10000];
	byte bytmp[];

	int specialMode = 0, nowVolume = 80;
	boolean soundPlaying = false;
	Sound playingData;

	public void main() {
		boolean showInformationAndQuit = true;

		if ((getKey() & EVENT_LAUNCHED) != 0) {
			bytmp = getLaunchParameter();
			if (bytmp != null) {
				String sttmp = new String(bytmp);
				if (sttmp.startsWith("http://") || sttmp.startsWith("https://")) {
					if (showDialog("̂܂ܒڂ͕\łȂ߁Axjiglet.infõNbVy[WɃANZX܂B" + sttmp,
					               DIALOG_TYPE_YES_NO) == DIALOG_YES) {
						launch(getSourceURL() + "vsjump.php?url=" + sttmp, ENCODE_SJIS, LAUNCH_TERMINATE);
					}
				} else {
					systemColors = getSystemColors();
					if (sttmp.startsWith("MThd")) {
						// GMt@C̉\A
						playingData = getSound(bytmp);
						if (playingData != null) {
							showInformationAndQuit = false;
							setSoftLabel("|>");
							specialMode = 1;
						}
					}
					if (specialMode == 0) {
						sourceData = sttmp;
						setFont(nowFont);
						fontHeight = getFontHeight() + getFontHeight() / 4;
						showableWidth = DW - (scrollBarWidth = (DW > 240 ? 6 : 3));
						showableLines = DH / fontHeight;
						showableChars = showableWidth / getFontHeight() * 2;
						nowLineID = drawStartPos = drawLeftOffset = 0;
						showInformationAndQuit = false;
						makeLineBreakInfos();
						setMenu(menuFace, menuHelp);
						setSoftLabel("COPY");
					}
				}
			}
		}

		if (showInformationAndQuit) {
			String ret;
			showDialog("URLҏW܂URL͂ŁA\URL̑OɈȉURLǋLĂB(OKƃeLXgҏWʂɂȂ܂A̓vtBbNX̃Rs[pł) " +
			           getSourceURL() + "viewsource.jiglet?urlparam=vsjump.php?url=", DIALOG_TYPE_OK);
			for (int endflag = 0; endflag == 0; ) {
				ret = inputText(getSourceURL() + "viewsource.jiglet?urlparam=vsjump.php?url=", TEXT_ALPHA);
				if ((ret != null) && (! ret.equals(getSourceURL() + "viewsource.jiglet?urlparam=vsjump.php?url="))) {
					if (showDialog("̉ʂŕҏWĂN܂Bx\܂H", DIALOG_TYPE_YES_NO) == DIALOG_NO) {
						endflag = 1;
					}
				} else {
					endflag = 1;
				}
			}
			return;
		}

		clearKey();
		int key;
		for (;;) {
			key = getKey();
			switch (specialMode) {
				case 1:
					keyevSoundMode(key);
					break;
				default:
					keyevNormalMode(key);
					break;
			}
			repaint();
			sleep(10);
		}
	}

	void keyevNormalMode(int key) {
		if (key < 0x100) {
			// Key pressed Event
			switch (key & 0xff) {
				case KEY_UP:
					if (nowLineID > 0) {
						drawStartPos = lineInfos[--nowLineID];
					}
					break;
				case KEY_DOWN:
					if (nowLineID < maxLines - showableLines - 1) {
						drawStartPos = lineInfos[++nowLineID];
					}
					break;
				case KEY_LEFT:
					if ((nowLineID -= showableLines - 1) < 0) {
						nowLineID = 0;
					}
					break;
				case KEY_RIGHT:
					if ((nowLineID += showableLines - 1) > maxLines - showableLines - 1) {
						nowLineID = maxLines - showableLines - 1;
					}
					break;
				case KEY_SOFT:
					inputText(sourceData.substring(lineInfos[nowLineID], lineInfos[nowLineID + showableLines]), TEXT_KANA);
					break;
			}

		} else if ((key & EVENT_MENU) != 0) {
			if ((key & 0xFFFF) < menuFace.length) {
				setSoftLabel(null);
				switch (key & 0xFFFF) {
					case 0:
						// ShiftJIS
						sourceData = new String(bytmp);
						break;
					case 1:
						// EUC
						sourceData = convertEUC2SJIS(bytmp);
						break;
					case 2:
						// JIS
						sourceData = convertJIS2SJIS(bytmp);
						break;
					case 3:
						// UTF-8
						sourceData = convertUTF8toUTF16(bytmp);
						break;
					case 4:
						// FONT = SMALL
						setFont(nowFont = FONT_SMALL);
						repaint();
						fontHeight = getFontHeight() + getFontHeight() / 4;
						break;
					case 5:
						// FONT = MEDIUM
						setFont(nowFont = FONT_MEDIUM);
						repaint();
						fontHeight = getFontHeight() + getFontHeight() / 4;
						break;
					case 6:
						// FONT = LARGE
						setFont(nowFont = FONT_LARGE);
						repaint();
						fontHeight = getFontHeight() + getFontHeight() / 4;
						break;
				}
				showableLines = DH / fontHeight;
				showableChars = showableWidth / getFontHeight() * 2;
				nowLineID = drawStartPos = drawLeftOffset = 0;
				makeLineBreakInfos();
				setMenu(menuFace, menuHelp);
				setSoftLabel("COPY");
			}
		}
	}
	void keyevSoundMode(int key) {
		if (key < 0x100) {
			// Key pressed Event
			switch (key & 0xff) {
				case KEY_UP:
					if (++nowVolume > 100) {
						nowVolume = 100;
					}
					setVolume(nowVolume);
					break;
				case KEY_DOWN:
					if (--nowVolume < 0) {
						nowVolume = 0;
					}
					setVolume(nowVolume);
					break;
				case KEY_SOFT:
					if (playingData != null) {
						if (soundPlaying) {
							setSoftLabel("|>");
							playSound(null);
							soundPlaying = false;
						} else {
							setSoftLabel("");
							setVolume(nowVolume);
							playSound(playingData);
							soundPlaying = true;
						}
					}
					break;
			}
		}
	}

	int strLastIndexOf(String source, String instr, int startPos, int limitPos) {
		int lastPos = (limitPos < 0 ? 0 : limitPos), checkPos;
		while ((checkPos = source.indexOf(instr, lastPos)) < startPos) {
			lastPos = checkPos + 1;
		}
		return(lastPos);
	}
	
	boolean makeLineBreakInfos() {
		if (sourceData == null) {
			return(false);
		}

		int i, heresLineBreak;

		lineInfos[0] = 0;
		isLineBreak[0] = false;
		maxLines = 1;
		for (i = 0; i < sourceData.length() - 1; ) {
			if (i < sourceData.length() - showableChars) {
				heresLineBreak = getLineBreak(sourceData, i, sourceData.length(), showableWidth);
			} else {
				heresLineBreak = sourceData.length() - 1;
			}
			if (isLineBreak[maxLines] = (heresLineBreak > sourceData.indexOf("\n", i))) {
				heresLineBreak = sourceData.indexOf("\n", i) + 1;
			}
			if (heresLineBreak < i) {
				heresLineBreak = sourceData.length() - 1;
			}
			lineInfos[maxLines++] = i = heresLineBreak;
			if ((maxLines & 127) == 0) {
				statusText = "͒...(" + i + "/" + sourceData.length() + ") " + maxLines + "s";
				statusPercentage = i * 1000 / sourceData.length();
				repaint();
			}
			if (maxLines >= 10000) {
				showDialog("ős10000sẑŒ~܂Bȍ~͕\܂B", DIALOG_TYPE_OK);
				maxLines = 9999;
				break;
			}
		}
		if (lineInfos[maxLines - 1] < sourceData.length() - 1) {
			lineInfos[maxLines++] = sourceData.length() - 1;
		}
		statusText = null;
		return(true);
	}
	
	public void paint(boolean allDrawFlag) {
		if (systemColors == null) {
			return;
		}

		setFont(nowFont);
		setColor(systemColors[SYSTEM_COLOR_MENU_BG]);
		fillRect(0, 0, DW, DH);

		switch (specialMode) {
			case 1:
				paint_soundMode(allDrawFlag);
				break;
			default:
				paint_normalMode(allDrawFlag);
		}
	}

	void paint_soundMode(boolean allDrawFlag) {
		setColor(systemColors[SYSTEM_COLOR_BUTTON_FONT1]);
		drawString("Volume : " + nowVolume, 0, getFontHeight());
		return;
	}
	
	void paint_normalMode(boolean allDrawFlag) {
		if (sourceData == null) {
			setColor(systemColors[SYSTEM_COLOR_BUTTON_FONT1]);
			drawString("wait...", 0, DH);
			return;
		}

		if (statusText != null) {
			setColor(systemColors[SYSTEM_COLOR_STATUS_BG1]);
			fillRect(0, DH - fontHeight, showableWidth, fontHeight);
			setColor(systemColors[SYSTEM_COLOR_STATUS_BG2]);
			// statusPercentage  1000{l (33.3% = x 0.333 = 333)
			if (statusPercentage > 1000) {
				statusPercentage = 1000;
			}
			fillRect(0, DH - fontHeight, showableWidth * statusPercentage / 1000, fontHeight);
			setColor(systemColors[SYSTEM_COLOR_STATUS_FONT]);
			drawString(statusText, 0, DH - 2);
			return;
		}

		int nowDrawPos = drawStartPos, heresLineBreak, rightCount;
		boolean drawLineBreakMark = false;
		String tmpDraw;

		if (nowDrawPos < 0) {
			nowDrawPos = 0;
		}

		setColor(systemColors[SYSTEM_COLOR_BUTTON_FONT1]);
		for (int i = 0; i < showableLines; i++) {
			if (i + nowLineID + 1 > maxLines) {
				break;
			}
			if (lineInfos[nowLineID + i + 1] - lineInfos[nowLineID + i] > 0) {
				tmpDraw = sourceData.substring(lineInfos[nowLineID + i], lineInfos[nowLineID + i + 1]);
				drawString(tmpDraw, 0, i * fontHeight + getFontHeight());
				rightCount = stringWidth(tmpDraw);
			} else {
				rightCount = 0;
			}
		}

		setColor(systemColors[SYSTEM_COLOR_SCROLL_BG]);
		fillRect(DW - scrollBarWidth, 0, scrollBarWidth, DH);
		setColor(systemColors[SYSTEM_COLOR_SCROLL_BAR]);
		fillRect(DW - scrollBarWidth, DH * nowLineID / maxLines, scrollBarWidth, DH * showableLines / maxLines + 1);
	}

	String convertJIS2SJIS(byte in[]) {
		int b1, b2;
		boolean isKanji = false;
		byte target[] = new byte[in.length];

		for (int i = 0, j = 0; i < in.length; ) {
			if (in[i] == 0x1b) {
				// ESC char, toggle Kanji mode
				isKanji = ! isKanji;
				i += 3;
				continue;
			}
			if (isKanji) {
				// Kanji mode

				if (in[i] < 0x2f) {
					// JIS code can be with control-chars,
					// Because, control-chars found if in kanji mode is bug or broken.
					// If then, escape from kanji mode with it for repair this Strings.
					isKanji = false;
					target[j++] = in[i++];
				}

				// JIS code has only 7bit chars, do not have to up-convert to int from byte
				if (i > in.length - 1) {
					break;
				}
				b1 = in[i++];
				b2 = in[i++];
				if ((b2 += ((b1 % 2) != 0 ? 0x1f : 0x7d)) >= 0x7f) {
					b2++;
				}
				if ((b1 = ((b1 += (b1 % 2)) / 2 + 0x70)) >= 0xa0) {
					b1 += 0x40;
				}
				target[j++] = (byte)(b1 > 127 ? b1 - 256 : b1);
				target[j++] = (byte)(b2 > 127 ? b2 - 256 : b2);
			} else {
				target[j++] = in[i++];
			}
			if ((i & 1023) == 0) {
				statusText = "R[hϊ...(" + i + "/" + in.length + ")";
				statusPercentage = i * 1000 / in.length;
				repaint();
			}
			if (i >= in.length) {
				break;
			}
		}
		statusText = null;
		String retStr = new String(target);
		int retCutPos = retStr.indexOf(0);
		if (retStr.indexOf(0) == 0) {
			return("");
		}
		return(retCutPos < 0 ? retStr : retStr.substring(0, retCutPos));
	}
	String convertEUC2SJIS(byte in[]) {
		int b1, b2;
		byte target[] = new byte[in.length];

		for (int i = 0, j = 0; i < in.length; ) {
			if (in[i] < 0) {
				// Kanji mode
				// EUC is capable for having negative(8bit) chars
				// But, because all chars are shift 0x80 from JIS code,
				// get chars for process got for only doing plus 256.
				if (i > in.length - 1) {
					break;
				}
				b1 = 128 + (int)(in[i++]);
				b2 = 128 + (int)(in[i++]);

				if ((b2 += ((b1 % 2) != 0 ? 0x1f : 0x7d)) >= 0x7f) {
					b2++;
				}
				if ((b1 = ((b1 += (b1 % 2)) / 2 + 0x70)) >= 0xa0) {
					b1 += 0x40;
				}
				target[j++] = (byte)(b1 > 127 ? b1 - 256 : b1);
				target[j++] = (byte)(b2 > 127 ? b2 - 256 : b2);
			} else {
				target[j++] = in[i++];
			}
			if ((i & 1023) == 0) {
				statusText = "R[hϊ...(" + i + "/" + in.length + ")";
				statusPercentage = i * 1000 / in.length;
				repaint();
			}
			if (i >= in.length) {
				break;
			}
		}
		statusText = null;
		String retStr = new String(target);
		return(retStr);
	}
	String convertUTF8toUTF16(byte in[]) {
		/*
			̃R[h͈ȉURLeQlɍ쐬܂B
			http://homepage1.nifty.com/nomenclator/unicode/ucs_utf.htm
		*/
		int j = 0;
		char target[] = new char[in.length];

		for (int i = 0; i < in.length; ) {
			if (byte2int(in[i]) < 0x80) {
				// 1byte chars
				target[j++] = (char)(byte2int(in[i++]));
			} else if (byte2int(in[i]) < 0xe0) {
				// 2byte chars
				target[j++] = (char)((byte2int(in[i]) & 0x1f) * 0x40 + (byte2int(in[i + 1]) & 0x3f));
				i += 2;
			} else if (byte2int(in[i]) < 0xf0) {
				// 3byte chars
				target[j++] = (char)((byte2int(in[i]) & 0xf) * 0x1000 + (byte2int(in[i + 1]) & 0x3f) * 0x40 + (byte2int(in[i + 2]) & 0x3f));
				i += 3;
			} else if (byte2int(in[i]) < 0xf8) {
				// 4byte chars
				// it cannot be set for char, skip
				target[j++] = '?';
				i += 4;
			} else {
				target[j++] = '?';
				i++;
			}

			if ((i & 1023) == 0) {
				statusText = "R[hϊ...(" + i + "/" + in.length + ")";
				statusPercentage = i * 1000 / in.length;
				repaint();
			}
			if (i >= in.length) {
				break;
			}
		}
		char target2[] = new char[j];
		arraycopy(target, 0, target2, 0, j);
		statusText = null;
		String retStr = new String(target2);
		return(retStr);
	}
	private int byte2int(byte in) {
		return((in < 0 ? in + 256 : in));
	}
}
